/* comp.c */

# include <stdio.h>
# define ALPSIZ 128
# define BIG 100
static char bigbuf[BIG];
static char *cursor;		/* cursor ptr */
static FILE *codfil;
/* static */ char *pp;		/* prev ptr */
/* static */ char *ppp;		/* prev prev ptr */

extern char *dict[];
extern int count;
extern timer(), setbit(), init(), doadd();
extern int prev;
extern int leng[];
extern long hashed[];
long harr[BIG];

sndstr() {
	char *newpat;
	int s;			/* best matching string number so far */
	register int i;		/* loop var */
	int l;			/* length of longest match so far */
	int t;			/* temp length */
	int patlen;		/* length of string at cursor */
	int hs,hl;		/* hash versions of s and l */

	patlen = strlen(cursor); /* get pattern length */
	{
		char *tp;
		long v;
		int i;

		tp = cursor;
		v = 0;
		for( i = 0; i < patlen; i++ ) {
			v = ((v << 7) + (v >> (36 - 7))) ^ *tp++;
			harr[i] = v;
		}
	}

	/* find longest dict entry match */

	hs = s = -1;		/* dict entry of best so far */
	hl = l = 0;		/* length of above */
	ppp = pp;
	pp = cursor;

	if( patlen > 1 ) {


		for( i = ALPSIZ; i < count; i++ ) { /* dict loop */
			register char *pat, *dp;

			if( leng[i - ALPSIZ] > patlen ) continue; /* too big */
			if( leng[i - ALPSIZ] < l ) continue; /* too small? */

			if( hashed[i - ALPSIZ] == harr[leng[i - ALPSIZ]-1] ) {
				hs = i;
				hl = leng[i - ALPSIZ];
			}

			dp = dict[i];
			pat = cursor;
			t = 0;

			while( *pat == *dp ) { /* string loop */
				if( *pat == '\0' ) break; /* both ended!! */

				t++;	/* our length */
				pat++;	/* bump temp cursor */
				dp++;	/* bump dict ptr */
			} /* string loop */

			if( *dp == '\0' && t > l ) { /* full match? */
				s = i;	/* save string number */
				l = t;	/* save length */
				newpat = pat; /* save updated cursor */
				if( *pat == '\0' ) break;
			} /* full match? */
		} /* dict loop */
		if( hs != s ) {
			printf("hs = %d, hl = %d\n",hs,hl);
			if( hs > 0 ) printf("%s\n",dict[hs]);
			printf("s = %d, l = %d\n",s,l);
			if( s > 0 ) printf("%s\n",dict[s]);
			if( l > 0 )
				printf("harr=%d, hashed=%d\n",harr[l-1],
					hashed[s - ALPSIZ]);
		}
	} /* patlen > 1 */

	if( l <= 0 ) s = *cursor++; /* no match, use single char */
	else cursor = newpat; /* else update cursor */
		
	setbit(s);		/* preserve lastest match */
	if( prev != -1 ) {
		int q;
		timer();	/* NUR tick */
		setbit(prev);	/* and previous */
		q = doadd(prev,s); /* concatenate them and add */
		if( ppp == NULL ) printf("ouch!!\n");
		else {
			char *tp;
			long v;
			int i;

			tp = ppp;
			v = 0;
			for( i = 0; i < leng[q-ALPSIZ]; i++ )
				v = ((v << 7) + (v >> (36 - 7))) ^ *tp++;

			hashed[q - ALPSIZ] = v;
		}
	} /* have prev */

	prev = s;
	return( s );
} /* sndstr */

dmpfl2(f)
FILE *f;
{
	int i;
	int total, sent, nrec;

	total = 0;
	sent = 0;
	nrec = 0;

	while( fgets(bigbuf,BIG,f) ) {
		total += strlen(bigbuf);
		cursor = bigbuf;
		prev = -1;
		pp = NULL;
		ppp = NULL;

		printf("%d\n",-1);
		nrec++;
		while( *cursor != '\0' ) {
			i = sndstr();
			printf("%d\n",i);
			sent++;
		}
	}

	fprintf(stderr,"total %d\n",total);
	fprintf(stderr,"sent  %d\n",sent);
	fprintf(stderr,"nrec  %d\n",nrec);
	fprintf(stderr,"count %d\n",count);
} /* dmpfl2 */

dmpfil(s)
char *s;
{
	FILE *f;
	if( (f = fopen(s,"r")) == NULL ) {
		fprintf(stderr,"Could not open %s\n",s);
		return;
	}

	dmpfl2(f);

	if( fclose(f) != NULL )
		fprintf(stderr,"Could not open %s\n",s);
} /* dmpfil */

main(argc,argv)
int argc;
char *argv[];
{
	int dumpf = 0;

	init();
	if( argc < 2 )
		dmpfl2(stdin);
	else {
		for( argv++ ; argc > 1 ; argc--, argv++ ) {
			if( strcmp(*argv,"-d") == 0 ) dumpf++;
			else dmpfil(*argv);
		}
	}

	if( dumpf > 0 ) dump();
} /* main */
