/* expd.c */

# include <stdio.h>
# define ALPSIZ 128

extern char *dict[];
extern int prev;
extern int count;
extern init();
extern timer();

expand(i)
int i;
{
	if( i == -1 ) {
		prev = -1;
		return;
	}

	if( i < ALPSIZ ) {
		putchar(i);
	}
	else {
		fputs(dict[i],stdout);
	}

	if( prev != -1 ) {
		timer();
		setbit(prev);
		setbit(i);
		doadd(prev,i);
	}

	prev = i;
} /* expand */

expfil(s)
char *s;
{
	FILE *codfil;
	int i;

	if( (codfil = fopen(s,"r")) == NULL ) {
		fprintf(stderr,"Cannot open %s\n",s);
		return;
	}

	while( fscanf(codfil,"%d",&i) == 1 )
		expand(i);

	if( fclose(codfil) != NULL )
		fprintf(stderr,"Could not close %s\n",s);
} /* expfil */

main(argc,argv)
int argc;
char *argv[];
{
	int dumpf = 0;

	init();
	if( argc < 2 )
		expfil("comp.codes");
	else {
		for( argv++ ; argc > 1 ; argc--, argv++ ) {
			if( strcmp(*argv,"-d") == 0 ) dumpf++;
			else expfil(*argv);
		}
	}

	fprintf(stderr,"%d entries used\n",count);
	if( dumpf > 0 ) dump();

} /* main */
